WITH   Gnat.IO ;  USE Gnat.IO;

PROCEDURE   PrimeNb  IS
   IsPrimeArray : Array(1..1000) of Boolean ;
   j , jMax : Integer ;
BEGIN
   Put (   "***** PRIME NUMBERS: "   );

   ----- LOOP 1 , On each number
   FOR i in 1..1000 LOOP

      ----- Could be a prime number
      IsPrimeArray(i) := TRUE ;

      j    := 2 ;
      jMax := Integer( i / 2 );
      
      ----- LOOP 2 , Search a divisor
      WHILE IsPrimeArray(i) and (j <= jMax) LOOP
         ----- "j" can divide "i" ?
         IF (i mod j) = 0 THEN
            IsPrimeArray(i) := False ;
         END IF;
         j := j + 1 ;
      END LOOP;
      
      ----- Display only prime numbers
      IF IsPrimeArray(i) = TRUE THEN
         Put (   i   );
         Put (   " "   );
      END IF;
   END LOOP;
   
--
--   [<--                   i                      -->]
--    [<-- j -->]
--   .#.....................#.........................#
--    |         |                                     |
--    2      i div 2                                1000
--
END;
